package nl.dragontamerfred.YRPerks.Commands;

import nl.dragontamerfred.YRPerks.GUI.AdminGui;
import nl.dragontamerfred.YRPerks.GUI.MainGui;
import nl.dragontamerfred.YRPerks.Messages;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class CommandPerks implements CommandExecutor {

    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
        if (sender instanceof Player) {
            Player player = ((Player) sender);
            if (args.length == 1) {
                if (args[0].equalsIgnoreCase("admin")) {
                    if (player.hasPermission("perks.admin")) {
                        new AdminGui().open(player, player);
                    } else {
                        player.sendMessage(Messages.PREFIX + Messages.NO_PERMISSION);
                    }
                } else if (player.hasPermission("perks.gui.open.others")) {
                    Player toView = Bukkit.getPlayer(args[0]);
                    if (toView == null) {
                        player.sendMessage(Messages.PREFIX + Messages.PLAYER_NOT_FOUND.replaceAll("<PLAYER_NAME>", args[0]));
                    } else {
                        new MainGui().open(toView, player);
                    }
                } else {
                    player.sendMessage(Messages.PREFIX + Messages.NO_PERMISSION);
                }
            } else if (args.length == 2) {
                if (args[0].equalsIgnoreCase("admin")) {
                    if (player.hasPermission("perks.admin")) {
                        Player target = Bukkit.getPlayer(args[1]);
                        if (target != null) {
                            new AdminGui().open(target, player);
                        } else {
                            player.sendMessage(Messages.PREFIX + Messages.PLAYER_NOT_FOUND.replaceAll("<PLAYER_NAME>", args[1]));
                        }
                    } else {
                        player.sendMessage(Messages.PREFIX + Messages.NO_PERMISSION);
                    }
                } else {
                    player.sendMessage(Messages.PREFIX + Messages.INVALID_USAGE);
                }
            } else if (player.hasPermission("perks.gui.open")) {
                new MainGui().open(player, player);
            } else {
                player.sendMessage(Messages.PREFIX + Messages.NO_PERMISSION);
            }
        } else {
            sender.sendMessage(Messages.PREFIX + Messages.NOT_A_PLAYER);
        }
        return true;
    }
}
