package nl.dragontamerfred.YRPerks.GUI;

import nl.dragontamerfred.YRPerks.Config;
import nl.dragontamerfred.YRPerks.PerkManager;
import nl.dragontamerfred.YRPerks.Types.ClassData;
import nl.dragontamerfred.YRPerks.Types.Classs;
import nl.dragontamerfred.YRPerks.Types.Level;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.InventoryView;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.HashMap;
import java.util.List;
import java.util.UUID;

public class AdminGui implements Listener {
    public static HashMap<UUID, InventoryView> openInvs = new HashMap<>();
    public static HashMap<UUID, UUID> staffViewing = new HashMap<>();

    public void open(Player target, Player staff) {
        Inventory inv = Bukkit.createInventory(null, 5*9, Config.INVENTORY_ADMIN_NAME);

        Classs classs = PerkManager.getSelectedClassForPlayer(target.getUniqueId());
        ClassData classData = PerkManager.getClassDataForPlayer(target.getUniqueId(), classs.id);

        if (classData == null) {
            staff.sendMessage("&cAn error occurred.");
            return;
        }

        ItemStack classItem = new ItemStack(classs.material, 1, classs.damage);
        ItemMeta classsMeta = classItem.getItemMeta();
        classsMeta.setDisplayName(classs.name);
        classsMeta.setLore(classs.description);
        classItem.setItemMeta(classsMeta);

        ItemStack subClassOneItem = new ItemStack(classs.subClassOne.material, 1, classs.subClassOne.damage);
        ItemMeta subClassOneMeta = subClassOneItem.getItemMeta();
        subClassOneMeta.setDisplayName(classs.subClassOne.name);
        List<String> subClassOneLore = classs.subClassOne.description;
        if (classData.subClassOne.unlocked)
            subClassOneLore.add("&aUnlocked");
        else
            subClassOneLore.add("&4Locked");
        subClassOneLore.add("&3Click to toggle unlocked status.");
        subClassOneMeta.setLore(subClassOneLore);
        subClassOneItem.setItemMeta(subClassOneMeta);

        ItemStack subClassTwoItem = new ItemStack(classs.subClassTwo.material, 1, classs.subClassTwo.damage);
        ItemMeta subClassTwoMeta = subClassTwoItem.getItemMeta();
        subClassTwoMeta.setDisplayName(classs.subClassTwo.name);
        List<String> subClassTwoLore = classs.subClassTwo.description;
        if (classData.subClassTwo.unlocked)
            subClassTwoLore.add("&aUnlocked");
        else
            subClassTwoLore.add("&4Locked");
        subClassTwoLore.add("&3Click to toggle unlocked status.");
        subClassTwoMeta.setLore(subClassTwoLore);
        subClassTwoItem.setItemMeta(subClassTwoMeta);

        for (int i=0; i<classs.levels.size(); i++) {
            inv.setItem(i+1, getLevelStack(classs.levels.get(i), classData.level<=i+1));
        }

        for (int i=0; i<classs.subClassOne.levels.size(); i++) {
            inv.setItem(i+10, getLevelStack(classs.subClassOne.levels.get(i), classData.subClassOne.level<=i+1));
        }

        for (int i=0; i<classs.subClassTwo.levels.size(); i++) {
            inv.setItem(i+19, getLevelStack(classs.subClassTwo.levels.get(i), classData.subClassTwo.level<=i+1));
        }

        // 0  1  2  3  4  5  6  7  8
        // 9  10 11 12 13 14 15 16 17
        // 18 19 20 21 22 23 24 25 26
        // 27 28 29 30 31 32 33 34 35
        // 36 37 38 39 40 41 42 43 44
        // 45 46 47 48 49 50 51 52 53

        inv.setItem(0, classItem);
        inv.setItem(9, subClassOneItem);
        inv.setItem(18, subClassTwoItem);

        staffViewing.put(staff.getUniqueId(), target.getUniqueId());
        openInvs.put(staff.getUniqueId(), staff.openInventory(inv));
    }

    private static ItemStack getLevelStack(Level level, boolean unlocked) {
        ItemStack levelStack = new ItemStack(Material.STAINED_GLASS_PANE, 1, unlocked ? (short) 14 : (short) 15);
        ItemMeta levelMeta = levelStack.getItemMeta();
        levelMeta.setDisplayName(level.name);
        List<String> lore = level.description;
        lore.add("&3Click to set level.");
        levelMeta.setLore(lore);
        levelStack.setItemMeta(levelMeta);
        return levelStack;
    }

    @EventHandler
    public void on(InventoryClickEvent event) {
        if (openInvs.get(event.getWhoClicked().getUniqueId()) == event.getView()) {
            Player viewer = ((Player) event.getWhoClicked());
            Player target = Bukkit.getPlayer(staffViewing.get(viewer.getUniqueId()));
            event.setCancelled(true);
            Classs classs = PerkManager.getSelectedClassForPlayer(target.getUniqueId());
            ClassData cd = PerkManager.getClassDataForPlayer(target.getUniqueId(), classs.id);
            switch (event.getSlot()) {
                case 0:
                    PerkManager.setClassUnlockedForPlayer(target.getUniqueId(), classs.id, !cd.unlocked);
                    break;
                case 1:
                    PerkManager.setClassLevelForPlayer(target.getUniqueId(), classs.id, 1);
                    break;
                case 2:
                    PerkManager.setClassLevelForPlayer(target.getUniqueId(), classs.id, 2);
                    break;
                case 3:
                    PerkManager.setClassLevelForPlayer(target.getUniqueId(), classs.id, 3);
                    break;
                case 4:
                    PerkManager.setClassLevelForPlayer(target.getUniqueId(), classs.id, 4);
                    break;
                case 5:
                    PerkManager.setClassLevelForPlayer(target.getUniqueId(), classs.id, 5);
                    break;
                case 9:
                    PerkManager.setSubclassUnlocedForPlayer(target.getUniqueId(), classs.id, 1, cd.subClassOne.unlocked);
                    break;
                case 10:
                    PerkManager.setSubclassLevelForPlayer(target.getUniqueId(), classs.id, 1, 1);
                    break;
                case 11:
                    PerkManager.setSubclassLevelForPlayer(target.getUniqueId(), classs.id, 1, 2);
                    break;
                case 12:
                    PerkManager.setSubclassLevelForPlayer(target.getUniqueId(), classs.id, 1, 3);
                    break;
                case 18:
                    PerkManager.setSubclassUnlocedForPlayer(target.getUniqueId(), classs.id, 2, cd.subClassTwo.unlocked);
                    break;
                case 19:
                    PerkManager.setSubclassLevelForPlayer(target.getUniqueId(), classs.id, 2, 1);
                    break;
                case 20:
                    PerkManager.setSubclassLevelForPlayer(target.getUniqueId(), classs.id, 2, 2);
                    break;
                case 21:
                    PerkManager.setSubclassLevelForPlayer(target.getUniqueId(), classs.id, 2, 3);
                    break;
            }
        }
    }
}
