package nl.dragontamerfred.YRPerks.GUI;

import nl.dragontamerfred.YRPerks.Config;
import nl.dragontamerfred.YRPerks.PerkManager;
import nl.dragontamerfred.YRPerks.Types.Perk;
import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.InventoryView;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.*;

public class PerkGui implements Listener {

    private static HashMap<UUID, InventoryView> openInvs = new HashMap<>();
    private static HashMap<UUID, Integer> perkSlots = new HashMap<>();

    public void open(Player player, int perkSlot) {
        Inventory inv = Bukkit.createInventory(null, 3*9, Config.INVENTORY_PERKS_NAME);
        perkSlots.put(player.getUniqueId(), perkSlot);

        int slot = 0;
        for (String perkID : PerkManager.getAllPerksForPlayer(player.getUniqueId())) {
            Perk perk = PerkManager.getPerkById(perkID);
            ItemStack is = new ItemStack(perk.material, 1, perk.damage);
            ItemMeta im = is.getItemMeta();
            im.setDisplayName(perk.name);
            List<String> lore = perk.description;
            lore.add(ChatColor.BLACK + perk.id);
            im.setLore(lore);
            is.setItemMeta(im);
            inv.setItem(slot, is);
            slot++;
        }

        // No perk item
        Perk noPerk = PerkManager.getPerkById("none");
        ItemStack noPerkItem = new ItemStack(noPerk.material, 1, noPerk.damage);
        ItemMeta noPerkMeta = noPerkItem.getItemMeta();
        noPerkMeta.setDisplayName(noPerk.name);
        List<String> lore = noPerk.description;
        lore.add(ChatColor.BLACK + noPerk.id);
        noPerkMeta.setLore(lore);
        noPerkItem.setItemMeta(noPerkMeta);
        inv.setItem(25, noPerkItem);

        // Back item
        ItemStack backItem = new ItemStack(Material.valueOf(Config.GENERAL_BACK_BUTTON_MATERIAL), 1, Config.GENERAL_BACK_BUTTON_DAMAGE);
        ItemMeta backItemMeta = backItem.getItemMeta();
        backItemMeta.setDisplayName(Config.GENERAL_BACK_BUTTON_NAME);
        backItem.setItemMeta(backItemMeta);

        inv.setItem(26, backItem);

        player.closeInventory();
        openInvs.put(player.getUniqueId(), player.openInventory(inv));
    }

    @EventHandler
    public void on(InventoryClickEvent event) {
        if (openInvs.getOrDefault(event.getWhoClicked().getUniqueId(), null) == event.getView()) {
            Player player = ((Player) event.getWhoClicked());
            event.setCancelled(true);
            if (event.getCurrentItem() != null) {
                if (event.getCurrentItem().getItemMeta() != null) {
                    if (Config.GENERAL_BACK_BUTTON_NAME.equals(event.getCurrentItem().getItemMeta().getDisplayName())) {
                        new MainGui().open(player, player);
                    } else if (event.getCurrentItem().getItemMeta().hasLore()) {
                        ItemStack is = event.getCurrentItem();
                        List<String> lore = is.getItemMeta().getLore();
                        Perk perk = PerkManager.getPerkById(lore.get(lore.size()-1).replaceAll(ChatColor.BLACK.toString(), ""));
                        if (perk != null) {
                            PerkManager.setPerkForSlot(player.getUniqueId(), perkSlots.get(player.getUniqueId()), perk.id);
                        }
                        new MainGui().open(player, player);
                    }
                }
            }
        }
    }

}
