package nl.dragontamerfred.YRPerks.Listeners;

import nl.dragontamerfred.YRPerks.Events.KillEvent;
import nl.dragontamerfred.YRPerks.Types.DamageCause;
import org.bukkit.Bukkit;
import org.bukkit.entity.Arrow;
import org.bukkit.entity.Player;
import org.bukkit.entity.Projectile;
import org.bukkit.entity.Snowball;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityDamageByEntityEvent;
import org.bukkit.event.entity.PlayerDeathEvent;

import java.util.HashMap;
import java.util.UUID;

public class KillListener implements Listener {

    private static HashMap<UUID, UUID> lastDamage = new HashMap<>();
    private static HashMap<UUID, DamageCause> lastDamageCause = new HashMap<>();

    @EventHandler
    public void on(EntityDamageByEntityEvent event) {
        if (event.getEntity() instanceof Player) {
            Player hit = ((Player) event.getEntity());
            if (event.getDamager() instanceof Player) {
                lastDamage.put(hit.getUniqueId(), event.getDamager().getUniqueId());
                lastDamageCause.put(hit.getUniqueId(), DamageCause.PVP);
            } else if (event.getDamager() instanceof Projectile) {
                if (((Projectile) event.getDamager()).getShooter() instanceof Player) {
                    lastDamage.put(hit.getUniqueId(), ((Player) ((Projectile) event.getDamager()).getShooter()).getUniqueId());
                    if (event.getDamager() instanceof Arrow)
                        lastDamageCause.put(hit.getUniqueId(), DamageCause.ARROW);
                    else if (event.getDamager() instanceof Snowball)
                        lastDamageCause.put(hit.getUniqueId(), DamageCause.SNOWBALL);
                }
            }
        }
    }

    @EventHandler
    public void on(PlayerDeathEvent event) {
        Player killed = event.getEntity();
        if (lastDamage.containsKey(killed.getUniqueId())) {
            Player killer = Bukkit.getPlayer(lastDamage.get(killed.getUniqueId()));
            Bukkit.getServer().getPluginManager().callEvent(new KillEvent(killer, killed, lastDamageCause.getOrDefault(killed.getUniqueId(), DamageCause.MISC)));
            lastDamage.remove(killed.getUniqueId());
            lastDamageCause.remove(killed.getUniqueId());
        }
    }
}
