package nl.dragontamerfred.YRPerks;

import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;

public class PerkSettings {

    // archersAgility
    public static int ARCHERS_AGILITY_DURATION;
    public static int ARCHERS_AGILITY_AMPLIFIER;

    // trustyBow
    public static int TRUSTY_BOW_DAMAGE;

    // blessingOfTheGoddess
    public static int BLESSING_OF_THE_GODDESS_CHANCE;
    public static int BLESSING_OF_THE_GODDESS_MAX_LEVEL;

    // goldedHeart
    public static int GOLDEN_HEART_CHANCE;
    public static int GOLDEN_HEART_MAX_HEARTS;

    // arrowSpawn
    public static int ARROW_SPAWN_AMOUNT;

    public static void load(File file) {
        try {
            if (!file.getParentFile().exists())
                file.getParentFile().mkdirs();
            if (!file.exists())
                Utils.ExportResource("/perks.yml", file);
            YamlConfiguration config = new YamlConfiguration();
            config.load(file);

            // archersAgility
            ARCHERS_AGILITY_DURATION = config.getInt("archersAgility.duration");
            ARCHERS_AGILITY_AMPLIFIER = config.getInt("archersAgility.amplifier");

            // trustyBow
            TRUSTY_BOW_DAMAGE = config.getInt("trustyBow.damage");

            // blessingOfTheGoddess
            BLESSING_OF_THE_GODDESS_CHANCE = config.getInt("blessingOfTheGoddess.chance");
            BLESSING_OF_THE_GODDESS_MAX_LEVEL = config.getInt("blessingOfTheGoddess.max-level");

            // goldenHeart
            GOLDEN_HEART_CHANCE = config.getInt("goldenHeart.chance");
            GOLDEN_HEART_MAX_HEARTS = config.getInt("goldenHeart.max-hearts");

            //arrowSpawn
            ARROW_SPAWN_AMOUNT = config.getInt("arrowSpawn.amount");

        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
