package nl.dragontamerfred.YRPerks.Perks;

import nl.dragontamerfred.YRPerks.Events.KillEvent;
import nl.dragontamerfred.YRPerks.PerkManager;
import nl.dragontamerfred.YRPerks.PerkSettings;
import nl.dragontamerfred.YRPerks.Types.Perk;
import nl.dragontamerfred.YRPerks.Utils;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.inventory.ItemStack;

import java.util.ArrayList;
import java.util.List;

public class PerkArrowSpawn extends Perk implements Listener {

    public PerkArrowSpawn() {
        this.id = "arrowSpawn";
        this.name = "Arrow Spawn";
        this.material = Material.ARROW;
        this.damage = 0;
        List<String> description = new ArrayList<>();
        description.add("After every kill");
        description.add("you'll be granted");
        description.add("a few arrows to");
        description.add("continue your");
        description.add("rampage.");
        this.description = Utils.color(description);
    }

    @EventHandler
    public void on(KillEvent event) {
        Player killer = event.getKiller();
        if (PerkManager.playerHasPerkSelected(killer.getUniqueId(), id)) {
            killer.getInventory().addItem(new ItemStack(Material.ARROW, PerkSettings.ARROW_SPAWN_AMOUNT));
        }
    }
}
