package nl.dragontamerfred.YRPerks;

import nl.dragontamerfred.YRPerks.Types.Perk;
import org.bukkit.ChatColor;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import javax.rmi.CORBA.Util;
import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.List;

public class Utils {

    public static ItemStack createPerkItemStack(Perk perk) {
        ItemStack perkStack = new ItemStack(perk.material, 1, perk.damage);
        ItemMeta perkMeta = perkStack.getItemMeta();
        perkMeta.setDisplayName(perk.name);
        List<String> lore = perk.description;
        lore.add(ChatColor.BLACK + perk.id);
        perkMeta.setLore(lore);
        perkStack.setItemMeta(perkMeta);
        return perkStack;
    }

    public static void ExportResource(String resourceName, File output) {
        try (InputStream stream = Util.class.getResourceAsStream(resourceName); OutputStream resStreamOut = new FileOutputStream(output)) {
            if (stream == null) {
                throw new Exception("Cannot get resource \"" + resourceName + "\" from Jar file.");
            }

            int readBytes;
            byte[] buffer = new byte[4096];
            while ((readBytes = stream.read(buffer)) > 0) {
                resStreamOut.write(buffer, 0, readBytes);
            }
        } catch (Exception ex) {
            YRPerks.logger.severe("Could not copy defaults from jar! The plugin wont work without these!");
        }
    }

    public static String color(String s) {
        return ChatColor.translateAlternateColorCodes('&', s);
    }

    public static List<String> color(List<String> ls) {
        List<String> r = new ArrayList<>();
        for (String s : ls) {
            r.add(color(s));
        }
        return r;
    }

}
